// demo.js

(function(ext) {
    var device = null;
	var tones ={"B0":31,"C1":33,"D1":37,"E1":41,"F1":44,"G1":49,"A1":55,"B1":62,
			"C2":65,"D2":73,"E2":82,"F2":87,"G2":98,"A2":110,"B2":123,
			"C3":131,"D3":147,"E3":165,"F3":175,"G3":196,"A3":220,"B3":247,
			"C4":262,"D4":294,"E4":330,"F4":349,"G4":392,"A4":440,"B4":494,
			"C5":523,"D5":587,"E5":659,"F5":698,"G5":784,"A5":880,"B5":988,
			"C6":1047,"D6":1175,"E6":1319,"F6":1397,"G6":1568,"A6":1760,"B6":1976,
			"C7":2093,"D7":2349,"E7":2637,"F7":2794,"G7":3136,"A7":3520,"B7":3951,
	"C8":4186,"D8":4699};
	var beats = {"Half":500,"Quarter":250,"Eighth":125,"Whole":1000,"Double":2000,"Zero":0};
    
	var levels = {
		ALLUMER:1,
		ETEINDRE:0
	};
    
	ext.resetAll = function(){};
	
	ext.runArduino = function(){
		
	};
	ext.ledRouge = function(level) {
        //device.send([6, levels[level]])
		runPackage(30,6,typeof level=="string"?levels[level]:new Number(level));
    };
	ext.ledOrange = function(level) {
        //device.send([12, levels[level]])
		runPackage(30,12,typeof level=="string"?levels[level]:new Number(level));
    };
	ext.ledVerte = function(level) {
        //device.send([11, levels[level]])
		runPackage(30,11,typeof level=="string"?levels[level]:new Number(level));
    };
	ext.ventilateur = function(level) {
        //device.send([4, levels[level]])
		runPackage(30,4,typeof level=="string"?levels[level]:new Number(level));
    };
	ext.lampe = function(level) {
        //device.send([9, levels[level]])
		runPackage(32,9,typeof level=="string"?levels[level]:new Number(level));
    };
	ext.cmdBuzzerNote = function(tone, beat) {
		var beat = "Half";
		runPackage(34,3,short2array(typeof tone=="number"?tone:tones[tone]),short2array(typeof beat=="number"?beat:beats[beat]));
    };
	ext.cmdUltrasonUneMesure = function(nextID){
		var deviceId = 36;
		var trig = 5;
		var echo = 2;
		getPackage(nextID,deviceId,trig,echo);
	}
	ext.cmdHumiditeUneMesure = function(nextID) {
		var deviceId = 31;
		var pin = 14; // C'est la broche A0
		getPackage(nextID,deviceId,pin);
    };
	ext.cmdSeuilSecheresseUneMesure = function(nextID){
		var deviceId = 30;
		var pin = 10;
		getPackage(nextID,deviceId,pin);
	};
	var _level = 0;
	ext.blink = function(){
		device.send([0x22, 0x23])
	}

	function sendPackage(argList, type){
		var bytes = [0xff, 0x55, 0, 0, type];
		for(var i=0;i<argList.length;++i){
			var val = argList[i];
			if(val.constructor == "[class Array]"){
				bytes = bytes.concat(val);
			}else{
				bytes.push(val);
			}
		}
		bytes[2] = bytes.length - 3;
		device.send(bytes);
	}
	
	function runPackage(){
		sendPackage(arguments, 2);
	}
	function getPackage(){
		var nextID = arguments[0];
		Array.prototype.shift.call(arguments);
		sendPackage(arguments, 1);
	}
	
	
    function processData(bytes) {
        trace(bytes);
    }

    // Extension API interactions
    var potentialDevices = [];
    ext._deviceConnected = function(dev) {
        potentialDevices.push(dev);

        if (!device) {
            tryNextDevice();
        }
    }

    function tryNextDevice() {
        // If potentialDevices is empty, device will be undefined.
        // That will get us back here next time a device is connected.
        device = potentialDevices.shift();
        if (device) {
            device.open({ stopBits: 0, bitRate: 115200, ctsFlowControl: 0 }, deviceOpened);
        }
    }

    function deviceOpened(dev) {
        if (!dev) {
            // Opening the port failed.
            tryNextDevice();
            return;
        }
        device.set_receive_handler('maq00',function(data) {
            processData(data);
        });
    };

    ext._deviceRemoved = function(dev) {
        if(device != dev) return;
        device = null;
    };

    ext._shutdown = function() {
        if(device) device.close();
        device = null;
    };

    ext._getStatus = function() {
        if(!device) return {status: 1, msg: 'maq00 disconnected'};
        return {status: 2, msg: 'maq00 connected'};
    }

    var descriptor = {};
	ScratchExtensions.register('maq00', descriptor, ext, {type: 'serial'});
})({});
