/*
#ifdef ME_PORT_DEFINED
  #undef ME_PORT_DEFINED
#endif
*/
//#include "MeOrion.h"
#include "Arduino.h"
#include "mapping.h"
#include "protocoleBT.h"
//#include "MeBuzzer.h"
#include "CBuzzer.h"

    /*
    int noteDurations[] = {
      8,8,4,4,4,4,
      4,
      8,8,4,4,4,4,
      4,
      8,8,4,4,4,4,2,
      8,
      8,8,4,4,4,2,
      4,
    };
    */
    unsigned int noteDurations[] = {
      16,16,8,8,8,8,
      8,
      16,16,8,8,8,8,
      8,
      16,16,8,8,8,8,4,
      16,
      16,16,8,8,8,4,
      8,
    };
    
    // notes in the melody:
    unsigned int melody[] = {
    NOTE_G4,//5  
    NOTE_G4,//5
    NOTE_A4,//6
    NOTE_G4,//5
    NOTE_C5,//1.
    NOTE_B4,//7
    0,
    NOTE_G4,//5
    NOTE_G4,//5
    NOTE_A4,//6
    NOTE_G4,//5
    NOTE_D5,//2.
    NOTE_C5,//1.
    0,
    NOTE_G4,//5
    NOTE_G4,//5
    NOTE_G5,//5.
    NOTE_E5,//3.
    NOTE_C5,//1.
    NOTE_B4,//7
    NOTE_A4,//6
    0,
    NOTE_F5,//4.
    NOTE_F5,//4.
    NOTE_E5,//3.
    NOTE_C5,//1.
    NOTE_D5,//2.
    NOTE_C5,//1.
    0,
    };
    
    unsigned int buzzerNotes[] = {
    31, // B0
    33, // C1
    35,
    37,
    39,
    41,
    44,
    46,
    49,
    52,
    55,
    58,
    62, // B1
    65, // C2
    69,
    73,
    78,
    82,
    87,
    93,
    98,
    104,
    110,
    117,
    123, // B2
    131, // C3
    139,
    147,
    156,
    165,
    175,
    185,
    196,
    208,
    220,
    233,
    247, // B3
    262, // C4
    277,
    294, // D4
    311,
    330, // E4
    349, // F4
    370,
    392, // G4
    415,
    440, // A4
    466,
    494, // B4
    523, // C5
    554,
    587,
    622,
    659,
    698,
    740,
    784,
    831,
    880,
    932,
    988, // B5
    1047, // C6
    1109,
    1175,
    1245,
    1319,
    1397,
    1480,
    1568,
    1661,
    1760,
    1865,
    1976, // B6
    2093, // C7
    2217,
    2349,
    2489,
    2637,
    2794,
    2960,
    3136,
    3322,
    3520,
    3729,
    3951, // B7
    4186, // C8
    4435,
    4699,
    4978};


// MeBuzzer buzzer(PIN_BUZZER);

CBuzzer::CBuzzer() {
  
}

void CBuzzer::Setup(unsigned char pin) {
  ucPin = pin;
  pinMode(ucPin, OUTPUT);
  digitalWrite(ucPin, HIGH);  
}
void CBuzzer::buzzerPlayDefaultMelody()
{
    for (unsigned int thisNote = 0; thisNote < 29; thisNote++) {

    // to calculate the note duration, take one second 
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    unsigned int noteDuration = noteDurations[thisNote];
//    buzzer.tone(melody[thisNote],noteDuration);
    tone(ucPin, melody[thisNote], noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    unsigned int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    // stop the tone playing:
//    buzzer.noTone();
    noTone(ucPin); 
    delay(10); 
    digitalWrite(ucPin, HIGH);
  }
}
//--------------------------------------------------------------------------------------------
// unsigned int buzzerPlayNote(unsigned int noteIndex, unsigned int NoteDuration = 16)
// 
// Joue une note d'une durée de 1000/NoteDuration ms
// noteIndex est l'indice de la note dans le tableau buzzerNotes[] (voir le fichier buzzer.h)
// 
//--------------------------------------------------------------------------------------------
void CBuzzer::buzzerPlayNote(unsigned int noteIndex, unsigned int NoteDuration = 8) 
{
   
    // to calculate the note duration, take one second 
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    unsigned int noteDuration = 1000/NoteDuration;
/*    
    buzzer.tone(buzzerNotes[noteIndex],noteDuration);

    
    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    unsigned int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    buzzer.noTone(); 
*/
    tone(ucPin, buzzerNotes[noteIndex],noteDuration);

    // pour distinguer les notes, laisser une pause entre elles
    // la durée de la note + 30% fonctionne bien :
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes); // delai entre les notes

    // stoppe la production de son sur la broche 8 :
    noTone(ucPin); digitalWrite(ucPin, HIGH);
    
    return;    
}
//--------------------------------------------------------------------------------------------
// unsigned int cmdBuzzerNote(unsigned int msg)
// 
// L'argument msg est de la form XY (voir signification en tête de ce fichier) : n'est pas utilisé ici
// 
// On klaxonne
// 
//--------------------------------------------------------------------------------------------
unsigned int  CBuzzer::cmdBuzzerNote(unsigned int msg) {

  Serial.print("void cmdBuzzerNote(unsigned int msg) - Valeur : ");
  Serial.println(msg);
  buzzerPlayNote(msg);
//  buzzerPlayDefaultMelody();
  return msg;
  
}
unsigned int CBuzzer::cmdBuzzerMelodie(unsigned int uiSousMessage) {
  unsigned int ret = uiSousMessage;
  // Pour le moment, il n'y a qu'une seule mélodie en service
  buzzerPlayDefaultMelody();
  return ret;
}
//--------------------------------------------------------------------------------------------
// void cmdActionnerBuzzer(unsigned int msg)
// 
// L'argument msg est de la form XY (voir signification en tête de ce fichier)
// 
// On extrait le chiffre le plus à droite
// 
// Si BUZZER_NOTE,  
// Si BUZZER_MELODIE,  
// 
 //--------------------------------------------------------------------------------------------
int CBuzzer::cmdActionnerBuzzer(unsigned int msg) {
  int res = 0;
  Serial.print("void cmdActionnerBuzzer(unsigned int msg) - Message à traiter : ");
  Serial.println(msg);
  unsigned char ucCommande = msg;
  unsigned int uiSousMessage = msg;
  if (msg >= PROTO_3) {
    ucCommande = msg / PROTO_3;
    uiSousMessage = msg - ucCommande * PROTO_3;
  }

//  Serial.print("void cmdActionnerBuzzer(unsigned int msg) - Valeur : ");
//  Serial.println(ucCommande);
  unsigned long uiAEnvoyer=0; unsigned int ret = 0;
  switch(ucCommande) {
    case BUZZER_NOTE : 
      Serial.println("void cmdActionnerBuzzer(unsigned int msg) - Jouer une note");
      res = cmdBuzzerNote(uiSousMessage);
      if (res == uiSousMessage) {
        // Envoyer acquittement
//        uiAEnvoyer = CMD_INTERNE*PROTO_1 + ACTIONNER_BUZZER*PROTO_2 + BUZZER_NOTE*PROTO_3 + uiSousMessage;
        //btRetourner(uiAEnvoyer); // Désactivé car cela plante la carte Arduino
//         btRetourner(CMD_INTERNE, ACTIONNER_BUZZER, BUZZER_NOTE, uiSousMessage); 
      }
      break;
    case BUZZER_MELODIE : 
//      Serial.println("void cmdActionnerBuzzer(unsigned int msg) - Activer le buzzer sophistiqué");
      res = cmdBuzzerMelodie(uiSousMessage);
      if (res == uiSousMessage) {
        // Envoyer acquittement
        // uiAEnvoyer = CMD_INTERNE*PROTO_1 + ACTIONNER_BUZZER*PROTO_2 + BUZZER_MELODIE*PROTO_3 + uiSousMessage;
//         btRetourner(CMD_INTERNE, ACTIONNER_BUZZER, BUZZER_MELODIE, uiSousMessage); 
      }
      break;
      
    default : 
      break;
  }  
  return msg;
 }
