#include <Arduino.h>
#include "mapping.h"
#include "protocoleBT.h"
#include "CHumidite.h"

CHumidite::CHumidite() {
  
}

void CHumidite::Setup(unsigned char pinAnalogique, unsigned char pinDigital) {
  ucPinAnalogique = pinAnalogique;
  ucPinDigital = pinDigital;
  pinMode(ucPinAnalogique, INPUT);       //pin en entrée analogique
  pinMode(ucPinDigital, INPUT);  //pin en entrée numérique
}
unsigned int CHumidite::cmdHumiditeUneMesure(int iMsg) {
  unsigned int uiHSol = analogRead(ucPinAnalogique);  // On lit la valeur
//  Serial.print("int cmdHumiditeUneMesure() - Mesure d'humidité du sol : "); Serial.println(uiHSol); 
  uiHSol=uiHSol*100.0/1023;
//  Serial.print("int cmdHumiditeUneMesure() - Mesure d'humidité du sol : "); Serial.println(uiHSol); 
  return uiHSol;
}
unsigned int CHumidite::cmdSeuilSecheresseUneMesure(int iMsg) {
  unsigned int uiSeuil = digitalRead(ucPinDigital);  // On lit la valeur
//  Serial.print("int cmdSeuilSecheresseUneMesure() - Mesure seuil sécheresse du sol : "); Serial.println(uiSeuil); 
  return uiSeuil;
}
/*********************************************************************************************************************
 * void cmdActionnerCapteurHumidite(unsigned int msg)
 * 
 * L'argument msg est de la form XY (voir signification en tête de ce fichier)
 * 
 * On extrait le chiffre le plus à droite
 * 
 * Si ULTRASON_ON, on active la mesure de distance 
 * Si ULTRASON_OFF, on désactive la mesure de distance 
 * 
 ********************************************************************************************************************/
 int CHumidite::cmdActionnerCapteurHumidite(unsigned int msg) {
  int res = 0;
//  Serial.print("void cmdActionnerUltrason(unsigned int msg) - Message à traiter : ");
//  Serial.println(msg);
  unsigned char ucCommande = msg;
  unsigned int uiSousMessage = msg;
  if (msg >= PROTO_3) {
    ucCommande = msg / PROTO_3;
    uiSousMessage = msg - ucCommande * PROTO_3;
  }

//  Serial.print("void cmdActionnerUltrason(unsigned int msg) - Valeur : ");
//  Serial.println(ucCommande);
  unsigned long uiAEnvoyer=0; unsigned int ret = 0;
  switch(ucCommande) {
    case HUMIDITE_UNE_MESURE : 
//      Serial.println("void cmdActionnerCapteurHumidite(unsigned int msg) - Effectuer une mesure d'humidité du sol");
        ret = cmdHumiditeUneMesure(uiSousMessage);
//      if (ret == uiSousMessage) {
        // Envoyer acquittement
        //uiAEnvoyer = CMD_INTERNE*PROTO_1 + ACTIONNER_ULTRASON*PROTO_2 + ULTRASON_UNE_MESURE*PROTO_3 + ret;
        btRetourner(CMD_INTERNE, ACTIONNER_CAPTEUR_HUMIDITE, HUMIDITE_UNE_MESURE, ret);
//        Serial.println(uiAEnvoyer);
//        BT.print(uiAEnvoyer);
//      }
      break;
    case SECHERESSE_UNE_MESURE : 
//      Serial.println("void cmdActionnerCapteurHumidite(unsigned int msg) - Effectuer une mesure d'humidité du sol");
        ret = cmdSeuilSecheresseUneMesure(uiSousMessage);
//      if (ret == uiSousMessage) {
        // Envoyer acquittement
        //uiAEnvoyer = CMD_INTERNE*PROTO_1 + ACTIONNER_ULTRASON*PROTO_2 + ULTRASON_UNE_MESURE*PROTO_3 + ret;
        btRetourner(CMD_INTERNE, ACTIONNER_CAPTEUR_HUMIDITE, SECHERESSE_UNE_MESURE, ret);
//        Serial.println(uiAEnvoyer);
//        BT.print(uiAEnvoyer);
//      }
      break;
      
    default : 
      break;
  }  
  return msg;
 }
