#include <SoftwareSerial.h>
#include "FIFO.h"
#include "mapping.h"
#include "protocoleBT.h"
#include "CLed.h"
#include "CRelais.h"
#include "CGradateur.h"
#include "CBuzzer.h"
#include "CUltrason.h"
#include "CHumidite.h"

#ifdef MODE_BLUETOOTH_SIMULE
#define BT  Serial
#else
SoftwareSerial BT(BT_PORT_SERIE_RX, BT_PORT_SERIE_TX); //RX, TX respectivement
#endif

long baud_rates[]={1200,2400,4800,9600,19200,38400,57600,74880,115200};

FIFO btFifo;
/*
extern CLed ledRouge;
extern CLed ledOrange;
extern CLed ledVerte;
extern CRelais ventilateur;
extern CGradateur lampe;
extern CBuzzer buzzer;
extern CUltrason ultrason;;
extern CHumidite   humidite;
*/
void setupBT(unsigned long baudRate)
{
  pinMode(BT_PORT_SERIE_RX, INPUT);
  pinMode(BT_PORT_SERIE_TX, OUTPUT);
  BT.begin(baudRate);//baud_rates[BT_RIGHT_BAUD_RATE_INDEX]);//baud_rates[BT_DEFAULT_BAUD_RATE_INDEX]);// Le bluetooth communique par les pin 6 et 7
  // On initialise le baud rate du module bluetooth à 115200

   // Ces 3 lignes sont à exécuter une seule fois afin de paramétrer le module BT
  /*
  BT.print("AT+BAUD"+String(7));//String(BT_RIGHT_BAUD_RATE_INDEX+1));
  delay(1500);
  BT.begin(115200);//baud_rates[BT_RIGHT_BAUD_RATE_INDEX]);// Le bluetooth communique par les pin 6 et 7
  

  // Changement du nom du module bluetooth : à exécuter une seule fois
  String strName = BT_RIGHT_NAME;
  BT.print("AT+NAME:"+strName);
  delay(1500);
 */
/*
  BT.begin(9600);
  delay(500);
 
  BT.print("AT");
  delay(500);
 
  BT.print("AT+VERSION");
  delay(500);
 
  String strName = BT_RIGHT_NAME;
  BT.print("AT+NAME:"+strName);
  delay(500);

  BT.print("AT+BAUD"+String(8));//String(BT_RIGHT_BAUD_RATE_INDEX+1));
  delay(500);
 
  if (BT.available() > 0)
      Serial.println(BT.readString());*/
 }

/*********************************************************************************************************************
 * bool btRetourner(unsigned char c1, unsigned char c2, unsigned char c3, unsigned int c4)
 * 
 * Retourne une trame par liaison BT. Typiquement c'est une valeur analogique (slider, ultrason, ...)
 * 
 * c1, c2, c3 : des chiffres du protocole
 * c4 : valeur sur trois chiffres
 * 
 ********************************************************************************************************************/
int btRetourner(unsigned char c1, unsigned char c2, unsigned char c3, unsigned int c4) {
  int res = 0;
  char retMsg[TAILLE_TRAME+2+1];
  sprintf(retMsg, "%c%1d%1d%1d%3d%c", DEBUT_TRAME, c1, c2, c3, c4, FIN_TRAME);
  Serial.println(retMsg);
  res = BT.print(retMsg);
  return res;
}
int btRetourner(unsigned char c1, unsigned char c2, unsigned int c4) {
  int res = 0;
  char retMsg[TAILLE_TRAME+2+1];
  sprintf(retMsg, "%c%1d%1d%3d%c", DEBUT_TRAME, c1, c2, c4, FIN_TRAME);
  Serial.println(retMsg);
  res = BT.print(retMsg);
  return res;
}
int btRetourner(unsigned long ulVal) {
  char msg[TAILLE_TRAME+2+1];
  sprintf(msg, "%c%ld%c", DEBUT_TRAME, ulVal, FIN_TRAME);
  Serial.println(msg);
  int ret = BT.print(msg);
  return ret;
}
/*
void cmdInterne(unsigned int msg) {
  int res = 0;
//  Serial.print("void cmdInterne(unsigned int msg) - Message à traiter : ");
//  Serial.println(msg);
  unsigned char ucCommande = msg / PROTO_2;
  unsigned int uiSousMessage = msg - ucCommande * PROTO_2;

  Serial.print("void cmdInterne(unsigned int msg) - Commande : ");
  Serial.println(uiSousMessage);

  switch(ucCommande) {
    case ACTIONNER_ULTRASON : 
      res = ultrason.cmdActionnerUltrason(uiSousMessage);
      if (res == uiSousMessage) {
      }
      break;
    case ACTIONNER_CAPTEUR_HUMIDITE : 
      res = humidite.cmdActionnerCapteurHumidite(uiSousMessage);
      if (res == uiSousMessage) {
      }
      break;
    case ACTIONNER_BUZZER : 
      res = buzzer.cmdActionnerBuzzer(uiSousMessage);
      if (res == uiSousMessage) {
          btRetourner(CMD_INTERNE, ACTIONNER_BUZZER, uiSousMessage);
      }
      break;
    default : 
      break;
  }
  
}
void cmdSortieLogique(unsigned int msg) {
  unsigned char ucCommande = msg / PROTO_2;
  unsigned int uiSousMessage = msg - ucCommande * PROTO_2;

  unsigned int res=0; int ordre=LOW; 
  unsigned long uiAEnvoyer;
  switch(ucCommande) {
    case ACTIONNER_LED_ROUGE : 
      if (uiSousMessage == 0) ordre = LOW; else ordre = HIGH;
      res = ledRouge.cmdActionnerLed(ordre);
      if (res == ordre) {
        // Envoyer acquittement
        btRetourner(SORTIE_LOGIQUE, ACTIONNER_LED_ROUGE, 0, ledRouge.bEtatLed);
//        uiAEnvoyer = SORTIE_LOGIQUE*PROTO_1 + ACTIONNER_LED_ROUGE*PROTO_2 + uiEtatLedRouge;
//        Serial.println(uiAEnvoyer);
//        BT.print(uiAEnvoyer);
      }
      break;
    case ACTIONNER_LED_ORANGE : 
      if (uiSousMessage == 0) ordre = LOW; else ordre = HIGH;
      res = ledOrange.cmdActionnerLed(ordre);
      if (res == ordre) {
        // Envoyer acquittement
        btRetourner(SORTIE_LOGIQUE, ACTIONNER_LED_ORANGE, 0, ledOrange.bEtatLed);
      }
      break;      
    case ACTIONNER_LED_VERTE : 
      if (uiSousMessage == 0) ordre = LOW; else ordre = HIGH;
      res = ledVerte.cmdActionnerLed(ordre);
      if (res == ordre) {
        // Envoyer acquittement
        btRetourner(SORTIE_LOGIQUE, ACTIONNER_LED_VERTE, 0, ledVerte.bEtatLed);
      }
      break;
    case ACTIONNER_RELAIS : 
      if (uiSousMessage == 0) ordre = HIGH; else ordre = LOW;
      res = ventilateur.cmdActionnerRelais(ordre);
      if (res == ordre) {
        // Envoyer acquittement
        btRetourner(SORTIE_LOGIQUE, ACTIONNER_RELAIS, 0, ordre);
      }
      break;
    default : 
      break;
  }
  
  
}
*/
/*********************************************************************************************************************
 * void cmdSortieAnalogique(unsigned int msg)
 * 
 * L'argument msg est de la form VWXY (voir signification en tête de ce fichier)
 * 
 * On extrait le chiffre le plus à gauche
 * 
 * Si AUTRES_SORTIE_ANALOGIQUE, on appelle la fonction avertisseurAutres 
 * Si FEUX, on appelle la fonction avertisseurFeux
 * 
 * Les fonctions appelées reçoivent le message en argument auquel le chiffre de gauche a été soutrait
 ********************************************************************************************************************/
/*void cmdSortieAnalogique(unsigned long msg) {
  unsigned int ucCommande = msg / PROTO_2;
  unsigned long uiSousMessage = msg - ucCommande * PROTO_2;


  unsigned long res=0;  
  unsigned long uiAEnvoyer;
  switch(ucCommande) {
    case ACTIONNER_LED_ROUGE : 
      res = ledRouge.cmdActionnerLed(uiSousMessage, false);
      if (res == uiSousMessage) {
        // Envoyer acquittement
        btRetourner(SORTIE_ANALOGIQUE, ACTIONNER_LED_ROUGE, 0, ledRouge.ucValLed);
      }
      break;
    case ACTIONNER_LED_ORANGE : 
      res = ledOrange.cmdActionnerLed(uiSousMessage, false);
      if (res == uiSousMessage) {
        // Envoyer acquittement
        btRetourner(SORTIE_ANALOGIQUE, ACTIONNER_LED_ORANGE, 0, ledOrange.ucValLed);
      }
      break;      
    case ACTIONNER_LED_VERTE : 
      res = ledVerte.cmdActionnerLed(uiSousMessage, false);
      if (res == uiSousMessage) {
        // Envoyer acquittement
        btRetourner(SORTIE_ANALOGIQUE, ACTIONNER_LED_VERTE, 0, ledVerte.ucValLed);
      }
      break;
    case ACTIONNER_GRADATEUR : 
      res = lampe.cmdActionnerGradateur(uiSousMessage, false);
      if (res == uiSousMessage) {
        // Envoyer acquittement
        btRetourner(SORTIE_ANALOGIQUE, ACTIONNER_GRADATEUR, 0, lampe.ucValGradateur);
      }
      break;

    default : 
      break;
  }
   
}
*/






/*********************************************************************************************************************
 * void traiteBTMessage()
 * 
 * Lit les données provenant du Bluetooth puis extrait le chiffre le plus à gauche
 * Si SORTIE_LOGIQUE, on appelle la fonction cmdSORTIE_LOGIQUE 
 * Si SORTIE_ANALOGIQUE, on appelle la fonction cmdSortieAnalogique
 * 
 * Les fonctions appelées reçoivent le message initial auquel le chiffre de gauche a été soutrait
 ********************************************************************************************************************/
unsigned long traiteBTMessage() {
  int iTailleTrame = TAILLE_TRAME; // Nb d'éléments utiles de la trame
  char c=0;
  /*static String sMessage=""; */
  static char csMessage[32]; static int csMsgIndex=0;
  static bool bTrameEnConstruction = false; // Trame en cours de constitution ou non
//  bool bDebutTrame = false;
//  bool bFinTrame = false;

  
  // Lecture du port série du bluetooth et stockage dans la Fifo
  // Il faudrait normalement faire ça par interruption
  while (BT.available()){  //Check if there is an available byte to read
    delay(BT_DELAI_LECTURE); //Delay added to make thing stable 
    char c = BT.read(); //Conduct a serial read
    // On ajoute le caractère reçu à la Fifo
    btFifo.push(c);
//    Serial.println(c);
//    Serial.print("H : "); Serial.print(btFifo.getHead()); Serial.print(" T : "); Serial.print(btFifo.getTail()); Serial.print(" S : "); Serial.println(btFifo.size());
//    Serial.print("H Mod 128 : "); Serial.println(btFifo.getHead() % 128);
  } 

  // Si la trame n'est pas en construction (pas de début de trame atteint), on cherche le début
  if (!bTrameEnConstruction) {
    while(btFifo.size() > 0) {
      c = btFifo.pop();
//      Serial.print("H : "); Serial.print(btFifo.getHead()); Serial.print(" T : ");  Serial.print(btFifo.getTail()); Serial.print(" S : "); Serial.println(btFifo.size());
//      Serial.print("H Mod 128 : "); Serial.println(btFifo.getHead() % 128);
      if (c == DEBUT_TRAME) {
        bTrameEnConstruction = true;
        //sMessage = "";
        csMessage[0]= '\0'; csMsgIndex=0;
//        Serial.println("Début de trame");
        break;
      }
    }
  }
  // Si la trame n'est pas en construction (pas de début de trame atteint), on sort
  if (!bTrameEnConstruction)
    return 0L;

  // Nous avons une trame en construction, on ajoute tous les éléments en tête de pile formant la trame
  while(true) { // Boucle sans fin
    // Si fin de Fifo, on sort
    if (btFifo.size() == 0) 
      break;
    else {
      c = btFifo.pop();
//      Serial.print("H : "); Serial.print(btFifo.getHead()); Serial.print(" T : ");  Serial.print(btFifo.getTail()); Serial.print(" S : "); Serial.println(btFifo.size());
//      Serial.print("H Mod 128 : "); Serial.println(btFifo.getHead() % 128);
    }
    // Si fin de trame atteinte, on sort
    if (c == FIN_TRAME){ 
//      Serial.println("Fin de trame");
      break;
    }
    // On n'a pas de fin de trame. Si la longueur de la trame est déjà atteinte, la trame n'est pas valide,
    // On sort
//    if (sMessage.length() >= TAILLE_TRAME) {
    if (strlen(csMessage) >= TAILLE_TRAME) {
      //sMessage="";
      csMessage[0]= '\0'; csMsgIndex=0;
      bTrameEnConstruction = false;
      return  0L;
    }
    else {
      csMessage[csMsgIndex]=c; csMsgIndex++; csMessage[csMsgIndex]='\0';
//      sMessage.concat(c);
//      sMessage += c; // On ajoute le caractère au message
//      Serial.print("Ajout : ");Serial.println(c);
      }
  }
    

  if (c == FIN_TRAME) {
    // A ce niveau on devrait avoir une trame valide
//    Serial.println(sMessage); 
//    Serial.println(csMessage); 
  //  Serial.print("head : "); Serial.print(head); Serial.print(" tail : "); Serial.println(tail);Serial.print(" taille : "); Serial.println(taille);
  
    unsigned long ulMessage = atol(csMessage);//sMessage.toInt();
    Serial.print("traiteBTMessage() - trame reçue : "); Serial.println(ulMessage);
/*  
    unsigned char ucTypeCommande = ulMessage / PROTO_1;
    unsigned long ulSousMessage = ulMessage - ucTypeCommande * PROTO_1;
  
//    Serial.print("traiteBTMessage() - Type de commande : ");
//    Serial.println(ucTypeCommande);
    
    switch(ucTypeCommande) {
      case SORTIE_LOGIQUE : 
//        Serial.print("traiteBTMessage() - appel cmdSortieLogique, ulSousMessage : "); Serial.println(ulSousMessage);
        cmdSortieLogique(ulSousMessage);
        break;
      case SORTIE_ANALOGIQUE : 
//        Serial.print("traiteBTMessage() - appel cmdSortieAnalogique, ulSousMessage : "); Serial.println(ulSousMessage);
        cmdSortieAnalogique(ulSousMessage);
        break;
      case CMD_INTERNE : 
//        Serial.print("traiteBTMessage() - appel cmdInterne, ulSousMessage : "); Serial.println(ulSousMessage);
        cmdInterne(ulSousMessage);
        break;
      default : 
        break;
    }
	*/
    //sMessage = ""; // On réinitialise la variable contenant la trame
    csMessage[0]= '\0'; csMsgIndex=0;
    bTrameEnConstruction = false;
	return ulMessage;
  }
  return 0L;
}
