//---------------------------------------------------------------------------------------------
//                                MODE SIMULATION DU BLUETOOTH
// Ce mode permet de passer les trames directement depuis un terminal série connecté sur les pins 0 et 1.
// C'est par défaut le moniteur série de l'IDE Arduino.
//
// Pour désactiver ce mode, il suffit de commenter la ligne "#define MODE_BLUETOOTH_SIMULE" en mettant // devant
//---------------------------------------------------------------------------------------------
//#define MODE_BLUETOOTH_SIMULE


/********************** Constantes pour le protocole Bluetooth *******************************/

#define TAILLE_TRAME  6

// les trames doivent obligatoirement être encadrées par ces éléments
#define DEBUT_TRAME '<'
#define FIN_TRAME '>'

#define PROTO_1 100000  // U
#define PROTO_2 10000   // V
#define PROTO_3 1000    // W
#define PROTO_4 100   // X

// Valeur pouvant être prise par U
#define SORTIE_LOGIQUE    1
#define SORTIE_ANALOGIQUE  2
    // Valeurs pouvant être prises par V pour U = SORTIE_LOGIQUE ou SORTIE_ANALOGIQUE
    #define ACTIONNER_LED_VERTE 3
    #define ACTIONNER_LED_ORANGE 5
    #define ACTIONNER_LED_ROUGE 6
    // Valeurs pouvant être prises par V pour U = SORTIE_LOGIQUE
    #define ACTIONNER_RELAIS 4
    // Valeurs pouvant être prises par V pour U = SORTIE_ANALOGIQUE
    #define ACTIONNER_GRADATEUR 9
#define CMD_INTERNE  3      // Commande à usage interne. Ne produit pas de sortie PIN
    // Valeurs pouvant être prises par V pour U = CMD_INTERNE
    #define ACTIONNER_ULTRASON 1
        // Valeurs pouvant être prises par W pour U = CMD_INTERNE et V = ACTIONNER_ULTRASON
        #define ULTRASON_OFF 0 // N'est pas utilisé
        #define ULTRASON_ON 1
        #define ULTRASON_UNE_MESURE 2
    #define ACTIONNER_CAPTEUR_HUMIDITE 2
        #define  HUMIDITE_UNE_MESURE  2
        #define  SECHERESSE_UNE_MESURE  3
    #define ACTIONNER_BUZZER 3
        #define BUZZER_NOTE 1
        #define BUZZER_MELODIE 2
        
/********************** Fin des constantes pour le protocole Bluetooth *******************************/

#define DEFAULT_BT_BAUD_RATE  57600 //115200 // redondant avec BT_RIGHT_BAUD_RATE_INDEX. Il faudra choisir

#define BT_DELAI_LECTURE  1 // Attente en ms après BT.available et avant lecture 
#define BT_DEFAULT_BAUD_RATE_INDEX  3   // Index du baud rate par défaut du bluetooth HC-06 dans le tableau baud_rates[]
#define BT_RIGHT_BAUD_RATE_INDEX    8   // Index du baud rate choisi pour le fonctionnement
#define BT_RIGHT_NAME "Platine 1"

#define SERIAL_BAUD_RATE_INDEX  8 // Index du baud rate du terminal série

void setupBT(unsigned long baudRate);
int btRetourner(unsigned long ulVal);
int btRetourner(unsigned char c1, unsigned char c2, unsigned char c3, unsigned int c4);
int btRetourner(unsigned char c1, unsigned char c2, unsigned int c4);
// void cmdSortieLogique(unsigned int msg);
// void cmdSortieAnalogique(unsigned int msg);
// void cmdInterne(unsigned int msg);
// void cmdConfiguration(unsigned int msg);
unsigned long traiteBTMessage();
